#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <graphics.h>
#include <math.h>

#define del 20
#define qua 0.001

int cx, cy;

void StartGraphics()
{
  int gdriver = DETECT, gmode, errorcode;
  initgraph(&gdriver, &gmode, "");
  errorcode = graphresult();
  if (errorcode != grOk)
  {
    printf("Graphics error: %s\n", grapherrormsg(errorcode));
    printf("Press any key to halt:");
    getch();
    exit(1);
  }
}

void DrawCoorSys()
{
  int i, s;
  setcolor(8);
  line(0, cy, getmaxx(), cy);
  line(cx, 0, cx, getmaxy());
  for(i=1; i*del<cx || i*del<cy; i++)
    for(s=-1; s<=1; s+=2)
    {
      if(i*del<cx && i*del>-cx) line(i*s*del+cx, cy-1, i*s*del+cx, cy+1);
      if(i*del<cy && i*del>-cy) line(cx-1, i*s*del+cy, cx+1, i*s*del+cy);
    }
  settextjustify(1,1);
  line(cx-1, 0, cx-3, 13);
  line(cx+1, 0, cx+3, 13);
  line(getmaxx(), cy-1, getmaxx()-13, cy-3);
  line(getmaxx(), cy+1, getmaxx()-13, cy+3);
  outtextxy(cx+del, cy+del/2, "1");
  outtextxy(cx+del/2, cy-del, "1");
  outtextxy(getmaxx()-12, cy+del/2, "x");
  outtextxy(cx+del/2, 12, "y");
}

void DrawGraphic()
{
  float y=0, x=0;
  int s;
  int fin1=0, fin2=0;
  while(!fin1 || !fin2)
  {
    for(s=-1; s<=1; s+=2)
    {
      x *= s;
      y = pow(x, 2);                              // <- HERE is the formula!
      if(s==-1) if((x*del<=-cx) || (y*del>=cy) || (y*del<=-cy)) fin1 = 1;
      if(s==1)  if((x*del>=cx)  || (y*del>=cy) || (y*del<=-cy)) fin2 = 1;
      if( (s==-1 && !fin1) || (s==1 && !fin2) ) putpixel(x*del+cx, -y*del+cy, 15);
//      getch();
      x *= s;
    }
    x += qua;
  }
}

void main()
{
  char key;
  StartGraphics();
  cx = getmaxx() / 2; cy = getmaxy() / 2;
  cleardevice();
  setbkcolor(7);
  DrawCoorSys();
  DrawGraphic();
  setcolor(8);
  settextjustify(0,0);
  outtextxy(10, getmaxy()-14, "Drawing complete");
  outtextxy(10, getmaxy()-4, "Press ESC to exit");
  while(key!=27) key = getch();
}